package com.zmofun.erase;

/*
	Copyright zmofun           All rights reserved!
	http://www.zmofun.com
	2000.1.14        TurboC++2.0

  zmofun@163.com
  2020.10.28～10.29    移植到JAVA版本
	
*/
import java.awt.Color;
import java.awt.Graphics;

public class Shape {
	int px, py, width;
	public int l, c;
	public int[][] s = new int[5][5];
	public int[][] b = new int[5][5];

	void getnextsh(int x, int y, int il, int ic, int level) {
		int no, i;
		int[][] shapeall = {
				{ 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
				{ 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
				{ 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0 },
				{ 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
				{ 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
				{ 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
				{ 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
				{ 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0 },
				{ 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0 }
		};
		no = ((int) (Math.random() * 10) % 6) + level;
		px = x;
		py = y;
		l = il;
		c = ic;
		for (i = 0; i < 25; i++) {
			s[i / 5][i % 5] = b[i / 5][i % 5];
			b[i / 5][i % 5] = shapeall[no][i];
		}
	}

	void move(int d) {
		switch (d) {
			case 1:
				px = px - width / 5;
				c--;
				break;
			case 2:
				px = px + width / 5;
				c++;
				break;
			default:
				py = py + width / 5;
				l++;
				break;
		}
	}

	void bar3D(Graphics g, int x, int y, int x2, int y2) {
		g.setColor(Color.RED);
		g.draw3DRect(x, y, x2 - x, y2 - y, true);
	}

	void bar(Graphics g, int x, int y, int x2, int y2) {
		g.setColor(Color.BLACK);
		g.drawRect(x, y, x2 - x, y2 - y);
	}

	void paint(Graphics g) {
		int i, j;
		for (i = 0; i < 5; i++)
			for (j = 0; j < 5; j++)
				if (s[i][j] > 0)
					bar3D(g, px + j * (width / 5) + 1, py + i * (width / 5) + 1,
							px + (j + 1) * (width / 5) - 1, py + (i + 1) * (width / 5) - 1);
	}

	void paintnext(Graphics g, int x, int y) {
		int i, j;
		// bar(g,x,y,x+width,y+width);
		for (i = 0; i < 5; i++)
			for (j = 0; j < 5; j++)
				if (b[i][j] > 0)
					bar3D(g, x + j * (width / 5) + 1, y + i * (width / 5) + 1,
							x + (j + 1) * (width / 5) - 1, y + (i + 1) * (width / 5) - 1);
	}

	void rotate() {
		int i, j;
		int[][] t = new int[5][5];
		for (i = 0; i < 5; i++)
			for (j = 0; j < 5; j++)
				t[i][j] = s[i][j];
		for (i = 0; i < 5; i++)
			for (j = 0; j < 5; j++)
				s[i][j] = t[4 - j][i];
	}

	void init(int x, int y, int w, int il, int ic, int level) {
		px = x;
		py = y;
		l = il;
		c = ic;
		width = w;
		getnextsh(x, y, il, ic, level);
	}
}
